#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum PeriodogramMethod {
    #[serde(rename = "WELCH_BLACKMAN")]
    WelchBlackman,
    #[serde(rename = "WELCH_HANN")]
    WelchHann,
    #[serde(rename = "WELCH_HAMMING")]
    WelchHamming,
    #[serde(rename = "WELCH_RECT")]
    WelchRect,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl PeriodogramMethod {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            PeriodogramMethod::WelchBlackman => "WELCH_BLACKMAN",
            PeriodogramMethod::WelchHann => "WELCH_HANN",
            PeriodogramMethod::WelchHamming => "WELCH_HAMMING",
            PeriodogramMethod::WelchRect => "WELCH_RECT",
            PeriodogramMethod::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for PeriodogramMethod {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for PeriodogramMethod {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for PeriodogramMethod {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<PeriodogramMethod, conjure_object::plain::ParseEnumError> {
        match v {
            "WELCH_BLACKMAN" => Ok(PeriodogramMethod::WelchBlackman),
            "WELCH_HANN" => Ok(PeriodogramMethod::WelchHann),
            "WELCH_HAMMING" => Ok(PeriodogramMethod::WelchHamming),
            "WELCH_RECT" => Ok(PeriodogramMethod::WelchRect),
            v => v.parse().map(|v| PeriodogramMethod::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for PeriodogramMethod {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<PeriodogramMethod, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the PeriodogramMethod enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
